/**
 * Appwarp client wrapper
 */
bento.define('appwarp', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    var nothing = function () {};
    var passToEventSystem = function () {};
    if (!window.AppWarp) {
        console.log('WARNING: Appwarp namespace not found.');
        return {};
    }
    window.AppWarp.WarpClient.initialize('9895063f36a86172634df044abe1fbf2adc10ec7d759749611a6e8bef5318354', 'f49b0fc4778615b080fc4ed36b53da4ef942cc995430bac9e101f1ad57643420');
    var warpClient = window.AppWarp.WarpClient.getInstance();

    // pass all events to eventsystem?
    // pass all responses to EventSystem
    Utils.forEach(window.AppWarp.Events, function (item, i, l, breakLoop) {
        var name = window.AppWarp.Events[item];
        if (!name.indexOf) {
            // not a string
            return;
        }
        if (name.indexOf('Done') < 0) {
            // all responses appear to end with "Done", otherwise they are notifications
            warpClient.setNotifyListener(item, function (evt) {
                // console.log('AppWarp event: ', name);
                EventSystem.fire(name, evt);
            });
        } else {
            warpClient.setResponseListener(item, function (evt) {
                // console.log('AppWarp event: ', name);
                EventSystem.fire(name, evt);
            });
        }
    });
    return window.AppWarp;
});