/**
 * Cutscene 8: defeated pigchef again TODO: need to spice this up, this cutscene is very boring...
 * @moduleName CutScene
 */
bento.define('components/cutscenes/cutscene8', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'entities/cutscene',
    'entities/character',
    'modules/localization',
    'entities/effect'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Cutscene,
    Character,
    Localization,
    Effect
) {
    'use strict';
    var Scene = function (settings) {
        return {
            start: settings.start,
            update: settings.update
        };
    };
    return function (settings) {
        var viewport = Bento.getViewport();
        var cutscene; // the Cutscene instance
        var tiled = Cutscene.tiled; // reference to objects in tiled
        var nextScene; // call this to go to next scene
        var talk; // call this to make actor talk
        var focusOn; // pan camera to actor
        /*
         * Actors
         */
        var actors = {};
        var setupActors = function () {
            actors.lee = new Character({
                position: tiled['player'].position,
                spriteSheet: 'boy/idle'
            });
            actors.pigchef = new Character({
                position: tiled['pigchef'].position,
                spriteSheet: 'pigchef/liedown',
                direction: -1
            });
            actors.rin = new Character({
                position: tiled['rin'].position,
                spriteSheet: 'krillin/idle'
            });
            // attach them
            Bento.objects.attach(actors.lee);
            Bento.objects.attach(actors.pigchef);
            Bento.objects.attach(actors.rin);

            // initial camera position and force it
            focusOn(actors.pigchef, true);
        };
        /*
         * Array of scenes
         */
        var scenes = [
            // scene1: talking
            new Scene({
                start: function () {
                    talk({
                        text: Localization.getText('cutscene8')['varka01'],
                        who: actors.pigchef,
                        onComplete: function () {
                            focusOn(actors.lee);
                        }
                    });
                    talk({
                        text: Localization.getText('cutscene8')['lee02'],
                        who: actors.lee,
                        onComplete: function () {
                            focusOn(actors.pigchef);
                        }
                    });
                    talk({
                        text: Localization.getText('cutscene8')['varka03'],
                        who: actors.pigchef,
                        onComplete: function () {
                            focusOn(actors.rin);
                        }
                    });
                    talk({
                        text: Localization.getText('cutscene8')['rin04'],
                        who: actors.rin,
                        waitTime: 240,
                        onComplete: function () {
                            focusOn(actors.rin);
                        }
                    });
                    talk({
                        text: Localization.getText('cutscene8')['rin05'],
                        who: actors.rin,
                        onComplete: function () {
                            focusOn(actors.lee);
                        }
                    });
                    talk({
                        text: Localization.getText('cutscene8')['lee06'],
                        who: actors.lee,
                        onComplete: nextScene
                    });
                }
            })
        ];

        var component = {
            name: 'cutscene', // should always be called 'cutscene'
            startCutscene: function (data) {
                Utils.forEach(scenes, function (scene, i, l, breakLoop) {
                    cutscene.addScene(scene);
                });
                nextScene();
            },
            setupActors: function () {
                setupActors();
            },
            attached: function (data) {
                cutscene = data.entity;
                nextScene = cutscene.nextScene;
                talk = cutscene.talk;
                focusOn = cutscene.focusOn;
            }
        };
        return component;
    };
});