/**
 * Overwrites/adds extra properties from Tiled
 * @moduleName ExtraProps
 */
bento.define('components/extraprops', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var nameProperties = Utils.nameToJson(settings.tiled.object.name);
        var component = {
            name: 'extraProps',
            start: function (data) {
                entity.getComponent('punchable', function (punchable) {
                    // overwrite health
                    if (nameProperties.hp) {
                        punchable.setMaxHealth(nameProperties.hp);
                    }
                });
            },
            destroy: function (data) {},
            update: function (data) {},
            draw: function (data) {},
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});