/**
 * Flashing by drawing the sprite again
 * @moduleName Flash
 */
bento.define('components/flash', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var sprite;
        var component = {
            name: 'flash',
            alpha: 1,
            start: function (data) {
                sprite = entity.getComponent('sprite');
            },
            destroy: function (data) {},
            update: function (data) {},
            draw: function (data) {
                var context = data.renderer.getContext();
                var alphaCache;
                if (component.flash && Math.floor(entity.timer / 4) % 2 === 0) {
                    alphaCache = context.globalAlpha;
                    context.globalAlpha = component.alpha;
                    context.globalCompositeOperation = 'lighter';
                    sprite.draw(data);
                    context.globalCompositeOperation = 'source-over';
                    context.globalAlpha = alphaCache;
                }
            },
            attached: function (data) {
                entity = data.entity;
            },
            flash: false
        };
        return component;
    };
});