/**
 * Component that draws a shadow of 1px to the left of text with an outline
 * @moduleName LeftShadow
 */
bento.define('components/leftshadow', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var canvas;
        var context;
        var initialRefresh = false;

        var refresh = function () {
            canvas = entity.getCanvas();
            context = canvas.getContext('2d');
            var temp = document.createElement('canvas');
            temp.width = canvas.width;
            temp.height = canvas.height;
            var tempContext = temp.getContext('2d');
            tempContext.drawImage(canvas, 0, 0, canvas.width, canvas.height, 0, 0, canvas.width, canvas.height);
            context.drawImage(temp, 0, 0, canvas.width - 2, canvas.height, 2, 0, canvas.width - 2, canvas.height);
            context.drawImage(temp, 0, 0, canvas.width - 4, canvas.height, 4, 0, canvas.width - 4, canvas.height);
        };

        var component = {
            name: 'leftShadow',
            start: function (data) {
                if (!initialRefresh) {
                    initialRefresh = true;
                    refresh();
                }
            },
            attached: function (data) {
                entity = data.entity;
            },
            refresh: refresh
        };
        return component;
    };
});