/**
 * Name
 * @moduleName Name
 *
 */
bento.define('components/name', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/utils',
    'bento/tween',
    'modules/text'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    Utils,
    Tween,
    Text
) {
    'use strict';
    return function (settings) {
        var offset = settings.offset || new Vector2(0, -48);

        var name = new Text({
            text: settings.name || 'Guest',
            font: 'font',
            fontSize: 10,
            fontColor: '#ffffff',
            align: 'center',
            textBaseline: 'middle',
            lineWidth: 1,
            strokeStyle: '#2e1c6a',
            pixelStroke: true // workaround for Cocoon bug
        });

        var entity;
        var component = {
            name: 'name',
            start: function () {
                Bento.objects.attach(name);
            },
            destroy: function () {
                Bento.objects.remove(name);
            },
            update: function () {
                name.position = entity.position.add(offset);
                name.transform.y = entity.transform.y;
                name.z = entity.z + 0.01;
            },
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});