/**
 * This component locks an orientation until the parent entity is removed from the game
 * In most cases you should attach this to a tween
 * @moduleName OrientationLock
 */
bento.define('components/orientationlock', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'managers/resolution'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    ResolutionManager
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    var id = 0;
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var name = settings.name || (++id).toString();
        var component = {
            name: 'orientationLock',
            start: function (data) {
                ResolutionManager.setSystemLock(true, name);
            },
            destroy: function (data) {
                ResolutionManager.setSystemLock(false, name);
            },
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});