/**
 * Paralax background layers
 * @moduleName Paralax
 * @snippet Paralax.snippet
Paralax({
    scrollFactor: new Vector2(0.5, 0.5)
})
 */
bento.define('components/paralax', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var scrollFactor = settings.scrollFactor;
        var originalPosition;
        var component = {
            name: 'paralax',
            start: function (data) {
                // store original position
                originalPosition = entity.position.clone();
            },
            destroy: function (data) {},
            update: function (data) {
                entity.position.x = originalPosition.x + viewport.x * scrollFactor.x;
                entity.position.y = originalPosition.y + viewport.y * scrollFactor.y;
            },
            draw: function (data) {},
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});