/**
 * Sort objects based on y position
 */
bento.define('components/sort', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'globals'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Globals
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var viewport = Bento.getViewport();
        var entity;
        var baseLayer = settings.baseLayer || Globals.Layers.ENEMIES;
        var component = {
            name: 'sort',
            start: function (data) {},
            destroy: function (data) {},
            update: function (data) {
                entity.z = baseLayer + entity.position.y / viewport.height;
            },
            draw: function (data) {},
            attached: function (data) {
                entity = data.entity;
            }
        };
        return component;
    };
});