/**
 * Stats for a character
 * @moduleName Stats
 */
bento.define('components/stats', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween
) {
    'use strict';
    /**
     * Describe your settings object parameters
     * @param {Object} settings
     */
    return function (settings) {
        var stats = {
            name: 'stats',
            level: 1,
            attack: 1,
            skill: 1,
            health: 10,
            stamina: Infinity,
            minHits: 3,
            coins: 0
        };
        // overwrite stats with settings
        Utils.extend(stats, settings, true);
        return stats;
    };
});