/**
 * A simple entity with an animation of rad tied up
 * @moduleName RadTiedUp
 */
bento.define('entities/props/radtiedup', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'bento/gui/text',
    'bento/utils',
    'bento/tween',
    'components/sort'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Sort
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();
        var sprite = new Sprite({
            spriteSheet: 'rad/tiedup'
        });
        var entity = new Entity({
            z: 0,
            name: 'radtiedup',
            family: [''],
            position: settings.position,
            updateWhenPaused: 0,
            components: [
                sprite,
                new Sort({})
            ]
        });
        return entity;
    };
});