/**
 * Streetlight prop
 * @moduleName StreetLight
 */
bento.define('entities/props/streetlight', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'components/sort'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Sort
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var boundingBox = new Rectangle(-12, -6, 16, 6);
        var sprite = new Sprite({
            imageName: 'city/streetlight'
        });
        var entity = new Entity({
            z: 0,
            name: 'prop',
            family: boundingBox ? ['solid'] : [],
            boundingBox: boundingBox,
            originRelative: new Vector2(0.5, 1),
            components: [
                sprite,
                new Sort({})
            ]
        });
        return entity;
    };
});