/**
 * Spawn enemies instantly on the spot
 * @moduleName InstantSpawn
 */
bento.define('entities/spawners/instantspawn', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'entities/spawner',
    'components/sort',
    'managers/ai',
    'modules/matchmanager'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Spawner,
    Sort,
    AiManager,
    MatchManager
) {
    'use strict';
    return function (settings) {
        var viewport = Bento.getViewport();

        var entity;

        settings.movePosition = function () {
            entity.position.x += 8;
            entity.position.y -= 8;
        };
        // make enemies jump inside, reducing the odds of them getting stuck
        settings.jumpDirectionX = -2;
        settings.jumpDirectionY = 0;
        if (settings && settings.tiled && settings.tiled.position && settings.tiled.position.x < 0) {
            settings.jumpDirectionX = 2;
        }
        entity = new Spawner(settings);
        /*entity.spawnEnemy = function (enemy) {
            //attach to stage, otherwise states dont exist
            enemy.position.x = entity.position.x;
            enemy.position.y = entity.position.y;
            Bento.objects.attach(enemy);
            if (MatchManager.isOnline) {
                // bug: when playing online, the enemy has the tendency to freeze here
                AiManager.distributeAiTasks();
            }
            enemy.getComponent('enemyController', function (enemyController) {
                if (!enemyController.active) {
                    enemyController.active = entity.activateEnemy;
                }
            });
        };*/
        return entity;
    };
});