/**
 * Dojo exit trigger
 * @moduleName ExitDojo
 */
bento.define('entities/triggers/exitdojo', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'components/trigger',
    'modules/matchmanager',
    'globals',
    'bento/components/nineslice',
    'components/debug',
    'gui/menus/levelend',
    'gui/fade',
    'components/modal'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Trigger,
    MatchManager,
    Globals,
    NineSlice,
    Debug,
    LevelEndMenu,
    Fade,
    Modal
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var rectangle = settings.rectangle || new Rectangle(0, 0, 0, 0);
        var trigger = new Trigger({
            onTrigger: function () {
                entity.removeSelf();
                // fade out and exit to worldmap
                new Fade({
                    onComplete: function () {
                        Bento.screens.show('screens/worldselect', {
                            target: 'worldmap'
                        });
                    }
                }).attach(new Modal({}));
            }
        });
        var entity = new Entity({
            z: 1,
            name: 'exit',
            family: ['triggers'],
            position: new Vector2(rectangle.x, rectangle.y),
            boundingBox: new Rectangle(0, 0, rectangle.width, rectangle.height),
            components: [
                trigger
            ]
        });
        return entity;
    };
});