/**
 * Random enemy for the Rad event
 * NOTE: check tiled for available rootPaths
 * @moduleName RadRandom
 */
bento.define('entities/triggers/radrandom', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'entities/enemies/pam',
    'entities/enemies/shirley',
    'entities/enemies/dog',
    'entities/enemies/karp',
    'entities/enemies/pig',
    'entities/enemies/twerka',
    'entities/enemies/punker',
    'entities/enemies/punkgirl',
    'entities/enemies/gangster',
    'entities/enemies/ratguy'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Pam,
    Shirley,
    Dog,
    Karp,
    Pig,
    Twerka,
    Punker,
    PunkGirl,
    Gangster,
    RatGuy
) {
    'use strict';
    var enemies = [
        Pam, Pam, Pam, 
        Shirley, Shirley, Shirley, 
        Dog, Karp, RatGuy, Twerka, Gangster, PunkGirl
    ];
    return function (settings) {
        var viewport = Bento.getViewport();
        var Constructor = enemies[Utils.getRandom(enemies.length)];
        return Constructor(settings);
    };
});