/**
 * Random enemy for the Rad event (during night levels)
 * NOTE: check tiled for available rootPaths
 * @moduleName RadRandomNight
 */
bento.define('entities/triggers/radrandomnight', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'entities/enemies/pam',
    'entities/enemies/shirley',
    'entities/enemies/cat',
    'entities/enemies/bird',
    'entities/enemies/pig',
    'entities/enemies/mrpigeon',
    'entities/enemies/punker',
    'entities/enemies/ratgirl'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    Pam,
    Shirley,
    Cat,
    Bird,
    Pig,
    MrPigeon,
    Punker,
    RatGirl
) {
    'use strict';
    var enemies = [
        Pam, Pam, Pam,
        Shirley, Shirley, Shirley,
        Cat, Bird, Pig, MrPigeon, Punker, RatGirl
    ];
    return function (settings) {
        var viewport = Bento.getViewport();
        var Constructor = enemies[Utils.getRandom(enemies.length)];
        return Constructor(settings);
    };
});