/**
 * Start trigger, not really a trigger actually, just an object to spawn the players at
 * @moduleName Start
 */
bento.define('entities/triggers/start', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'entities/walkable'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    WalkableArea
) {
    'use strict';
    return function (settings) {
        var behavior = {
            name: 'startBehavior',
            start: function () {
                var walkable = new WalkableArea({
                    start: entity.position
                });
                Bento.objects.attach(walkable);
            }
        };
        var entity = new Entity({
            z: 0,
            name: 'start',
            dimension: new Rectangle(-8, -8, 16, 16),
            components: [
                behavior
            ]
        });
        return entity;
    };
});