/**
 * target on the ground for the player to go to
 * @moduleName Target
 */
bento.define('entities/tutorial/target', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var targetBehavior = {
            name: 'behavior',
            wave: 0,
            update: function () {
                innerTarget.rotation += 0.03;
                targetBehavior.wave += 0.15;
                target.scale.x = 0.8 + Math.sin(targetBehavior.wave) * 0.1;
                target.scale.y = 0.4 + Math.sin(targetBehavior.wave) * 0.05;
            }
        };

        var innerTarget = new Entity({
            z: 2,
            name: 'target',
            components: [
                new Sprite({
                    imageName: 'tutorial/tutorial-target-4',
                    originRelative: new Vector2(0.5, 0.5)
                })
            ]
        });
        var target = new Entity({
            z: 2,
            name: 'target',
            position: settings.position,
            components: [
                innerTarget,
                targetBehavior
            ]
        });

        return target;
    };
});