window.VERSION = '0.0.0';
window.BUILD = 0;
window.VERSION = "1.2.1";
window.BUILD = 106;

// undefine require
if (window.require) {
    window.require = undefined;
}
if (window.define) {
    window.define = undefined;
}

if (bento.require.config) {
    // requirejs config
    bento.require.config({
        baseUrl: 'js',
        waitSeconds: 0
    });
}

// iOS requires a handleOpenURL defined as fast as possible
window.handleOpenURL = function (url) {
    // window.setTimeout(function() {
    //     window.alert('startup' + url);
    // }, 4000);
    // received url: lk05://1234
    window.cachedUrl = url;
};

window.startGame = function () {
    bento.require([
        'bento',
        'bento/math/vector2',
        'bento/math/rectangle',
        'bento/tween',
        'bento/autoresize',
        'utils',
        'init',
        'managers/resolution',
        'modules/localization'
    ], function (
        Bento,
        Vector2,
        Rectangle,
        Tween,
        AutoResize,
        Utils,
        Init,
        ResolutionManager,
        Localization // keep reference to Localization so it will survive quick reloading
    ) {
        // save state setup
        Bento.saveState.setId('beatstreet/');
        Bento.saveState.saveKeys = true;

        Bento.setup({
            name: 'Beat Street',
            canvasId: 'canvas',
            canvasDimension: ResolutionManager.canvasDimension,
            renderer: 'canvas2d',
            pixelSize: ResolutionManager.pixelSize,
            subPixel: true,
            preventContextMenu: true,
            manualResize: true,
            reload: {
                simple: 'mouseDown-right',
                assets: 'buttonDown-1',
                jump: 'buttonDown-2'
            },
            screenshot: 'buttonDown-q',
            dev: true
        }, function () {
            // initialization moved to Init module
            Init();
        });
    });
};

window.patchUrl = 'http://d3q8vwl9xlq0g.cloudfront.net/beatstreet/data';

document.addEventListener('deviceready', function () {
    var hasStarted = false;

    // window.patcher('http://localhost:8000/SkyChasers/misc/patch','v0.6.1', function (res) { // <- for testing
    window.patcher(window.patchUrl, 'v' + window.VERSION, function (res) {
        if (res) {
            console.log('Ended with', res);
        }
        if (!hasStarted) {
            window.startGame();
            hasStarted = true;
        }
    });
}, false);

