/**
 * Settings button
 * @moduleName SettingsButton
 */
bento.define('gui/buttons/settings', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'globals',
    'components/anchor',
    'gui/menus/cheat',
    'gui/menus/settings'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Globals,
    Anchor,
    CheatMenu,
    SettingsMenu
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();

        var button = new ClickButton({
            z: Globals.Layers.GUI,
            name: 'settingsButton',
            sfx: 'sfx_button',
            imageName: 'gui/buttons/settings',
            frameCountX: 2,
            frameCountY: 1,
            float: true,
            updateWhenPaused: 0,
            onClick: function () {
                var settingsMenu = new SettingsMenu(settings);
                Bento.objects.attach(settingsMenu);

            },
            onButtonDown: function () {
                //push button down
                EventSystem.fire('preventScroll');
            }
        });

        return button;
    };
});