/**
 * Section of the store to remove energy
 * @moduleName EnergySection
 */
bento.define('gui/iap/energysection', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'gui/iap/sectionlabel',
    'components/anchor',
    'gui/iap/moneypurchase'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    SectionLabel,
    Anchor,
    MoneyPurchase
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();

        var label = new SectionLabel({
            text: 'Energy',
        });

        var unlimitedEnergy = new MoneyPurchase({
            title: 'Unlimited Energy',
            item: 'energy',
            cost: '?',
            big: true,
            position: new Vector2(0, 23),
            onClick: function () {
                console.log('gain unlimited energy');
            }
        });

        var behavior = {
            name: 'behaviorComponent',
            start: function (data) {
                entity.dimension = new Rectangle(-93, 0, 186, 123);
            },
            destroy: function (data) {},
            update: function (data) {},
            draw: function (data) {}
        };
        var entity = new Entity({
            z: 0,
            name: 'energySection',
            updateWhenPaused: 0,
            dimension: new Rectangle(-93, 0, 186, 123),
            components: [
                label,
                unlimitedEnergy,
                behavior
            ]
        });
        return entity;
    };
});