/**
 * Item Descriptor
 *
 * @moduleName ItemDescriptor
 */
bento.define('gui/itemdescriptor', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();

        var nameText = new Text({
            z: 0,
            position: new Vector2(0, 0),
            text: '',
            font: 'font',
            fontSize: 16,
            fontColor: '#ffffff',
            align: 'left',
            textBaseline: 'bottom',
            ySpacing: 0,
            lineWidth: 0,
            strokeStyle: '#000000',
            innerStroke: false,
            pixelStroke: false // workaround for Cocoon bug
        });

        var descriptionText = new Text({
            z: 0,
            position: new Vector2(0, 18),
            text: '',
            font: 'font',
            fontSize: 16,
            fontColor: '#ffffff',
            align: 'left',
            textBaseline: 'bottom',
            ySpacing: 0,
            lineWidth: 0,
            strokeStyle: '#000000',
            innerStroke: false,
            pixelStroke: false // workaround for Cocoon bug
        });

        var entity = new Entity({
            z: 0,
            name: 'itemDescriptor',
            position: settings.position || new Vector2(0, 0),
            updateWhenPaused: 0,
            components: [
                nameText,
                descriptionText
            ]
        }).extend({
            setName: function (name) {
                nameText.setText(name);
            },
            setDescription: function (desc) {
                descriptionText.setText(desc);
            }
        });
        return entity;
    };
});