/**
 * Module description
 * @moduleName ConsumableButton
 */
bento.define('gui/main/consumable', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'managers/item'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    ItemManager
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
            item: Object // contains information about current item
        }*/

        // TODO: add consumable icon when implemented
        var icon = new Entity({
            z: 10,
            name: 'icon',
            family: [''],
            position: new Vector2(18.5, 22),
            components: [
                new Sprite({
                    spriteSheet: 'consumables/game/fries',
                    //originRelative: new Vector2(0.5, 0)
                })
            ]
        });

        var viewport = Bento.getViewport();
        var button = new Sprite({
            name: 'button',
            sfx: 'sfx_button',
            imageName: 'gui/main/itemframe',
            animations: {
                up: {
                    frames: [0]
                },
                down: {
                    frames: [0]
                }
            },
            onClick: function () {
                //consume consumable
            },
            onButtonDown: function () {
                //push labels of button down
                // icon.position.y = -1;
            },
            onButtonUp: function () {
                //pop labels back up
                // icon.position.y = -2;
            }
        });
        var entity = new Entity({
            z: 0,
            name: '',
            family: [''],
            position: settings.position,
            updateWhenPaused: 0,
            components: [
                button,
                icon
            ]
        });
        return entity;
    };
});