/**
 * Module description
 * @moduleName MainEquipment
 */
bento.define('gui/main/equipment', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'managers/inventory',
    'gui/main/consumable',
    'components/anchor',
    'globals'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    InventoryManager,
    ConsumableButton,
    Anchor,
    Globals
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
            character: String // current character
        }*/
        var viewport = Bento.getViewport();
        var equipped = InventoryManager.getEquipped(settings.character);
        var slot1 = new ConsumableButton({
            item: equipped[0]
        });
        var slot2 = new ConsumableButton({
            position: new Vector2(38, 0),
            item: equipped[1]
        });

        var behavior = {
            name: 'behaviorComponent',
            start: function (data) {},
            update: function (data) {}
        };
        var entity = new Entity({
            z: Globals.Layers.GUI,
            name: 'equipment',
            position: settings.position,
            scale: Vector2(0.75, 0.75),
            float: true,
            components: [
                slot1,
                slot2,
                behavior
            ]
        });

        entity.attach(new Anchor({
            screenPosition: new Vector2(0, 0),
            offset: new Vector2(50, 30)
        }));
        return entity;
    };
});