/**
 * Module description
 * @moduleName LevelCount
 */
bento.define('gui/main/levelcount', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();

        var counterFront = new Counter({
            value: settings.level,
            spacing: new Vector2(-3, 0),
            align: 'left',
            sprite: new Sprite({
                imageName: 'gui/main/lvlcount-front',
                frameCountX: 10,
                frameCountY: 1
            })
        });
        var counterBack = new Counter({
            value: settings.level || '',
            spacing: new Vector2(-3, 0),
            align: 'left',
            sprite: new Sprite({
                imageName: 'gui/main/lvlcount-back',
                frameCountX: 10,
                frameCountY: 1
            })
        });
        var entity = new Entity({
            name: 'levelCount',
            position: new Vector2(8, -7),
            updateWhenPaused: 0,
            components: [
                counterBack,
                counterFront
            ]
        });
        return entity;
    };
});