/**
 * Implements CurrencyCounter, keeps track of player's coins and allows the IAP shop to be opened
 * @moduleName PlayerCoins
 */
bento.define('gui/playercoins', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'gui/currencycounter',
    'components/eventlistener',
    'managers/save',
    'managers/inventory',
    'managers/currency'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    CurrencyCounter,
    EventListener,
    SaveManager,
    InventoryManager,
    CurrencyManager
) {
    'use strict';
    var PlayerCoins = function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var listener = new EventListener({
            name: 'updateCoins',
            onEvent: function (coins) {
                currencyCounter.setValue(coins);
            }
        });
        var currencyCounter;

        // TODO: make the counter clickable

        // pass settings values
        settings.value = CurrencyManager.getCoins();
        settings.imageName = 'gui/coin2';
        settings.name = 'playerCoins';

        // set up
        currencyCounter = new CurrencyCounter(settings).attach(listener);

        return currencyCounter;
    };

    return PlayerCoins;
});