/**
 * Same as Bento Text but drawn twice with a dark outline on the bottom
 * @moduleName ShadowText
 */
bento.define('gui/shadowtext', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween
) {
    'use strict';
    return function (settings) {
        var textSettings = {
            name: 'shadowText',
            fontColor: '#ffffff',
            shadowColor: '#2e1c6a',
            shadow: true,
            shadowOffset: settings.shadowOffset || new Vector2(0, 1)
        };
        // mix with settings object
        Utils.extend(textSettings, settings);

        return new Text(textSettings);
    };
});