/**
 * Single burst of sparkles for a short time
 * @moduleName SparkleBurst
 */
bento.define('gui/sparkleburst', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'components/sparkles'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    Sparkles
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var radius = settings.radius;
        var lifeTime = settings.lifeTime || 10;
        var sparkles = new Sparkles({
            offset: settings.offset,
            spawnRate: 0.5,
            speed: 2
        });
        var behavior = {
            name: 'behaviorComponent',
            start: function (data) {},
            destroy: function (data) {},
            update: function (data) {
                if (entity.timer > lifeTime) {
                    sparkles.setSpawnRate(0);
                }
                if (entity.timer > lifeTime + 120) {
                    entity.removeSelf();
                }
            }
        };
        var entity = new Entity({
            z: settings.z,
            name: 'sparkleBurst',
            position: settings.position,
            components: [
                sparkles,
                behavior
            ]
        });
        return entity;
    };
});