/**
 * Container showing the stats of the current character + stats for the next level
 * @moduleName Stats
 */
bento.define('gui/upgrade/statsbg', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'managers/save',
    'managers/character',
    'managers/stats',
    'components/debug',
    'gui/shadowtext',
    'components/shadow',
    'modules/localization',
    'bento/components/nineslice'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    SaveManager,
    CharacterManager,
    StatsManager,
    Debug,
    ShadowText,
    Shadow,
    Localization,
    NineSlice
) {
    'use strict';
    var StatsBg = function (settings) {
        var containerSprite = new NineSlice({
            imageName: 'gui2/misc/splash_background_9slice',
            width: 80,
            height: 96,
            originRelative: new Vector2(0.5, 0.5)
        });
        var statsContainer = new Entity({
            name: 'statsBg',
            position: settings.position,
            components: [
                containerSprite
            ].concat(settings.components || [])
        });
        return statsContainer;
    };

    return StatsBg;
});