/**
 * Tutorial entity used in the world select screen
 * @moduleName WorldTutorial
 */
bento.define('gui/worldtutorial', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/components/sprite',
    'bento/components/clickable',
    'bento/entity',
    'bento/eventsystem',
    'bento/gui/clickbutton',
    'bento/gui/counter',
    'modules/text',
    'bento/utils',
    'bento/tween',
    'managers/save',
    'components/tutorials/tutorial4',
    'components/tutorials/tutorial6'
], function (
    Bento,
    Vector2,
    Rectangle,
    Sprite,
    Clickable,
    Entity,
    EventSystem,
    ClickButton,
    Counter,
    Text,
    Utils,
    Tween,
    SaveManager,
    Tutorial4,
    Tutorial6
) {
    'use strict';
    return function (settings) {
        /*settings = {
            // describe your settings object parameters
            position: Vector2 // positions the entity
        }*/
        var viewport = Bento.getViewport();
        var behavior = {
            name: 'behaviorComponent',
            start: function (data) {
                var savedTutorial = SaveManager.load('tutorial');
                if (savedTutorial === 3) {
                    entity.attach(new Tutorial4({}));
                }
                // else if (savedTutorial === 4) {
                //     entity.attach(new Tutorial6({}));
                // }
            },
            destroy: function (data) {},
            update: function (data) {},
            draw: function (data) {}
        };
        var entity = new Entity({
            z: 0,
            name: 'worldTutorial',
            position: settings.position,
            updateWhenPaused: 0,
            components: [
                behavior
            ]
        });
        return entity;
    };
});