/**
 * Game specific module that creates a new test group. Patch this file to create new groups
 * @moduleName ABTestGroup
 */
bento.define('modules/abtestgroup', [
    'bento',
    'bento/math/vector2',
    'bento/math/rectangle',
    'bento/entity',
    'bento/eventsystem',
    'bento/utils',
    'bento/tween',
    'modules/abtest',
    'globals'
], function (
    Bento,
    Vector2,
    Rectangle,
    Entity,
    EventSystem,
    Utils,
    Tween,
    ABTest,
    Globals
) {
    'use strict';
    return function (settings) {
        var bootups = Bento.saveState.load('bootupsTotal', 0);
        var fingerprint = Bento.saveState.load('fingerPrint', null);

        // await event
        EventSystem.on('ABTest', function (data) {
            // PATCH THIS
            // specific things happening on test groups
            // patch other files if needed and use Bento.saveState.load('testGroup', '') to check testgroup name
            if (data.name === 'testGroupName') {
                // ...
            }
        });

        if (
            bootups === 0 &&            // only on first bootup
            !ABTest.isAnyTester() &&    // not testing yet
            Utils.getRandom(20) === 0          // 1/20 chance
        ) {            
            // PATCH THIS
            ABTest.shouldBecomeTester('noForcedAds');
        }
        Bento.saveState.add('bootupsTotal', 1);
    };
});