/**
 * Wrapper for Google Analytics Cordova plugin
 * @moduleName GoogleAnalytics
 */
bento.define('modules/googleanalytics', [
    'bento/utils'
], function (
    Utils
) {
    'use strict';
    var iOSId = 'UA-59807613-16';
    var androidId = 'UA-59807613-17';
    var nothing = function () {};
    var userId = '';

    if (!window.ga) {
        // try windows.analytics
        window.ga = window.analytics;
    }

    if (!window.ga || Utils.isDev()) {
        Utils.log('Google Analytics plugin not initialized');
        return {
            trackView: nothing,
            trackEvent: nothing,
            addTransactionItem: nothing,
            addCustomDimension: nothing,
            setUserId: nothing
        };
    } else {

    }

    // start
    if (navigator.isCocoonJS && window.Cocoon.getPlatform() === 'android') {
        window.ga.startTrackerWithId(androidId);
    } else if (navigator.isCocoonJS && window.Cocoon.getPlatform() === 'ios') {
        window.ga.startTrackerWithId(iOSId);
    }

    return {
        trackView: function (name) {
            window.ga.trackView(name);
        },
        trackEvent: function (category, action, label, value) {
            window.ga.trackEvent(category, action, label, value);
        },
        addTransaction: function (id, affiliation, revenue, tax, shipping, currencyCode) {
            window.ga.addTransaction(id, affiliation, revenue, tax, shipping, currencyCode);
        },
        addTransactionItem: function (id, name, sku, category, price, quantity, currencyCode) {
            window.ga.addTransactionItem(id, name, sku, category, price, quantity, currencyCode);
        },
        addCustomDimension: function (key, value, success, error) {
            window.ga.addCustomDimension(key, value, success, error);
        },
        setUserId: function (id) {
            userId = id;
            window.ga.setUserId(id);
        }
    };
});