/**
 * Photon classes
 * @moduleName PhotonClasses
 */
bento.define('photon', [
    'bento/utils',
    'bento/eventsystem'
], function (
    Utils,
    EventSystem
) {
    'use strict';
    if (!window.Photon) {
        console.log('WARNING: Photon namespace not found.');
        return {};
    }

    var Client = function (protocol, appId, appVersion) {
        window.Photon.LoadBalancing.LoadBalancingClient.call(this, protocol, appId, appVersion);
    };
    Client.prototype = Object.create(window.Photon.LoadBalancing.LoadBalancingClient.prototype);
    Client.prototype.constructor = Client;

    // overwrite callback functions
    Utils.forEach(window.Photon.LoadBalancing.LoadBalancingClient.prototype, function (value, key, l, breakLoop) {
        if (key.indexOf('on') === 0) {
            Client.prototype[key] = function () {
                /*console.log("EVENT " + key);
                Utils.forEach(arguments, function (item, i) {
                    console.log('argument ' + i, item);
                });*/
                EventSystem.fire(key, arguments);
            };
        }
    });
    var version = window.VERSION;
    // exception with version: v1.1.7 and v1.1.8 is compatible with v1.1.6
    if (version === '1.1.7' || version === '1.1.8') {
        version = '1.1.6';
    }
    // tower patch: ensure compatibility
    if (version === '1.2.0') {
        version = '1.2.0P';
    }

    var client = new Client(
        window.Photon.ConnectionProtocol.Ws,
        '1783c441-56fc-4de9-9c4b-2528e9a27407',
        version
    );

    client.setLogLevel(window.Exitgames.Common.Logger.OFF);

    return {
        client: client
    };
});